'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ActionCable = require('actioncable');

var LiveReloader = function () {
  function LiveReloader() {
    _classCallCheck(this, LiveReloader);
  }

  _createClass(LiveReloader, [{
    key: 'buildFreshUrl',
    value: function buildFreshUrl(url) {
      var date = Math.round(Date.now() / 1000).toString();
      url = url.replace(/(\&|\\?)version=\d*/, '');

      return '' + url + (url.indexOf('?') >= 0 ? '&' : '?') + 'version=' + date;
    }
  }, {
    key: 'cssReload',
    value: function cssReload(strategy) {
      var _this = this;

      switch (strategy) {
        case 'hot':
          var reloadableLinkElements = window.top.document.querySelectorAll('link[rel=stylesheet]:not([data-no-reload]):not([data-pending-removal])');

          [].slice.call(reloadableLinkElements).filter(function (link) {
            return link.href;
          }).forEach(function (link) {
            return link.href = _this.buildFreshUrl(link.href);
          });

          // Repaint
          var browser = navigator.userAgent.toLowerCase();

          if (browser.indexOf('chrome') > -1) {
            setTimeout(function () {
              document.body.offsetHeight;
            }, 25);
          }
          break;
        case 'page':
          window.top.location.reload();
          break;
        case 'off':
          break;
      }
    }
  }, {
    key: 'jsReload',
    value: function jsReload(strategy) {
      switch (strategy) {
        case 'page':
          window.top.location.reload();
          break;
        case 'off':
          break;
      }
    }
  }, {
    key: 'htmlReload',
    value: function htmlReload(strategy) {
      switch (strategy) {
        case 'turbolinks':
          var location = window.top.location;

          if (typeof Turbolinks !== 'undefined') {
            Turbolinks.visit(location);
          } else {
            location.reload();
          }
          break;
        case 'page':
          window.top.location.reload();
          break;
        case 'off':
          break;
      }
    }
  }, {
    key: 'init',
    value: function init() {
      var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      var reloaders = {
        js: this.jsReload.bind(this),
        css: this.cssReload.bind(this),
        html: this.htmlReload.bind(this)
      };

      document.addEventListener('DOMContentLoaded', function () {
        var Breakfast = window.Breakfast || {};
        Breakfast.options = options;

        var reloadChannel = 'Breakfast::LiveReloadChannel';

        Breakfast.cable = ActionCable.createConsumer('ws://' + options.host + ':' + options.port + '/cable');
        Breakfast.channel = Breakfast.cable.subscriptions.create(reloadChannel, {
          received: function received(data) {
            var reloader = reloaders[data.extension];
            reloader(options.reloadStrategies[data.extension]);
          }
        });
      });
    }
  }]);

  return LiveReloader;
}();

module.exports = LiveReloader;